/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "bounce.h"

int ifps=0;

POWERUP powerup[MAX_POWERUPS];
POWERUP_EFFECT powerupEffect[8];

char powerupText[7][12] = {"PowerBall \n",
                           "SlowDown  \n",
                           "Uber-bat  \n",
                           "Extra Life\n",
                           "SpeedUp   \n",
                           "Big Bat   \n",
                           "Small Bat \n"};

int powerups;
int powerupEffects;
float powerupVelocity;

float ballX, ballY, ballXVelocity, ballYVelocity, ballWidth, ballHeight;
float uberBatX;
float newBallX, newBallY;
float batX, batY, batWidth, batHeight;
float brickWidth, brickHeight;
float ballVelocity;

int timeElapsed;

bool holdingBall = true;
bool ballDownwards;
bool ballLeftwards;

int oldMouseX, oldMouseY;
MOUSE mouse;

float slowdownFactor;
float slowdown;

int screenWidth;
int screenHeight;

int boardWidth = RIGHT_BOUND-LEFT_BOUND;
int boardHeight = 200;

float wRatio, hRatio;

float colors[8][3];

int brick[COLUMNS][ROWS];
int levelBrick[10][COLUMNS][ROWS];
float brickCoord[COLUMNS][ROWS][2][2];

int startScreen;
int gameSection;
int gameOverSection;

int openingSelection;
int highScoreSelection;
int optionsSelection;
int exitSelection;

int difficulty;
int optionSound;
int optionMusic;

char names[5][4];
int highscores[5];
int highlevels[5];
int replace;
int cursor;

int score, level, lives;

int keyBatVelocity;

ALuint buffer[SOUNDS];
ALuint source[SOUNDS];

int main(int argc, char **argv)
{
   atexit(KillALData);
   myInit();
   initAL();
   glutInit(&argc, argv);
   glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
   glutCreateWindow("Bounce");
   glutFullScreen();
   glutDisplayFunc(renderScene);
   glutIdleFunc(idle);
   glutReshapeFunc(reshape);
   glutMouseFunc(processMouse);
   glutMotionFunc(processActiveMotion);
   glutKeyboardFunc(keyboard);
   glutSpecialFunc(special);
   glutPassiveMotionFunc(processPassiveMotion);
   glutSetCursor(GLUT_CURSOR_NONE);
   glPointSize(POWERUP_SIZE);
   glutMainLoop();
   return 0;
}

