/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "general.h"
#include "initialisation.h"
#include <stdio.h>
#include <string.h>
#include "types.h"
#include "sound.h"

extern float ballX, ballY, ballXVelocity, ballYVelocity, ballWidth, ballHeight;
extern float newBallX, newBallY;
extern float batX, batY, batWidth, batHeight;
extern float uberBatX;
extern float brickWidth, brickHeight;
extern float ballVelocity;
extern bool holdingBall;
extern bool ballDownwards;
extern bool ballLeftwards;
extern int oldMouseX, oldMouseY;
extern float brickCoord[COLUMNS][ROWS][2][2];
extern int brick[COLUMNS][ROWS];
extern int levelBrick[10][COLUMNS][ROWS];

extern int gameSection;
extern int gameOverSection;
extern float slowdownFactor;
extern int score, lives;
extern int replace;
extern int cursor;

extern ALuint source[SOUNDS];

extern int timeElapsed;


void newGame();
void launchBall(float colX);
void endOfLife();
void bounceWalls();
void bounceBat();
void bounceBrickLeft(int brickX, int brickY);
void bounceBrickRight(int brickX, int brickY);
void bounceBrickTop(int brickX, int brickY);
void bounceBrickBottom(int brickX, int brickY);
void bounceBrick();
void predictBallPosition();
void updateBallPosition();
void scorePoints(int value);
void newLevel();
void checkEndOfLevel();
void generatePowerup(int brickX, int brickY);
void powerupactivate(int color);
void powerupCatch();
void setBallVelocity();
void gameOver();
