/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "idle.h"

void idleStartGame()
{
}

void idleGame()
{
   if (holdingBall)
   {
      ballY = batY + batHeight;
      ballX = batX + batWidth / 2;
   }
   else
   {
      predictBallPosition();
      bounceBrick();
      bounceWalls();
      bounceBat();
      updateBallPosition();
   }

   if (powerups > 0)
   {
      dropPowerups();
      powerupCatch();
   }

   if (powerupEffects > 0)
      incPowerupEffects();

   if (mouse.left == GLUT_DOWN && slowdown > 0.0)
   {
      slowdown--;
      slowdownFactor = 0.3;
   }
   else
      slowdownFactor = 1.0;

   glutPostRedisplay();
}

void idleGameOver()
{
}

void idle(void)
{
   fps(1);
   timer();
   switch(gameSection)
   {
   case SECTION_START_SCREEN:
      idleStartGame();
      break;
   case SECTION_GAME:
      idleGame();
      break;
   case SECTION_GAME_OVER:
      idleGameOver();
      break;
   }
   glutPostRedisplay();
}

void dropPowerups()
{
   int i;
   for (i = 0; i < MAX_POWERUPS; i++)
      if (powerup[i].color > 0)
      {
         powerup[i].y -= powerupVelocity*GAME_SPEED*timeElapsed;
         if (powerup[i].y < BOTTOM_BOUND)
         {
            powerup[i].color = 0;
            powerups--;
         }
      }
}

void incPowerupEffects()
{
   int i;
   for (i = 1; i < 8; i++)
      if (powerupEffect[i].effect)
      {
         if (++powerupEffect[i].time > powerupEffect[i].duration)
         {
            powerupEffect[i].effect = false;
            powerupEffect[i].time = 0;
         }
      }
}

void timer()
{
   static int frame=0, timebase=0;
   int time;

   frame++;
   time=glutGet(GLUT_ELAPSED_TIME);
   timeElapsed=time-timebase;
   timebase = time;
}
