/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "initialisation.h"

void assignColors()
{
   colors[0][0] = 0.0;  colors[0][1] = 0.0;  colors[0][2] = 0.0;
   colors[1][0] = 1.0;  colors[1][1] = 0.0;  colors[1][2] = 0.0;
   colors[2][0] = 1.0;  colors[2][1] = 0.5;  colors[2][2] = 0.0;
   colors[3][0] = 1.0;  colors[3][1] = 1.0;  colors[3][2] = 0.0;
   colors[4][0] = 0.0;  colors[4][1] = 1.0;  colors[4][2] = 0.0;
   colors[5][0] = 0.0;  colors[5][1] = 0.0;  colors[5][2] = 1.0;
   colors[6][0] = 0.5;  colors[6][1] = 0.0;  colors[6][2] = 1.0;
   colors[7][0] = 1.0;  colors[7][1] = 0.0;  colors[7][2] = 1.0;
}

void myInit()
{

   openingSelection = SELECTION_NEW_GAME;
   optionsSelection = OPTIONS_DIFFICULTY;
   gameSection = SECTION_START_SCREEN;
   startScreen = START_OPENING;
   difficulty = DIFFICULTY_NORMAL;
   highScoreSelection = HIGH_SCORE_BACK;
   optionSound = SOUND_ON;
   /*optionMusic = MUSIC_ON;*/

   keyBatVelocity = KEY_BAT_VELOCITY;

   powerupVelocity = 3.0;

   ballHeight = 10;
   ballWidth = 10;

   batY = 20;
   batWidth=80;
   batHeight = 10;

   brickWidth = 50.0;
   brickHeight = 25.0;

   oldMouseX = -1;
   oldMouseY = -1;

   mouse.left = GLUT_UP;
   mouse.right = GLUT_UP;

   assignColors();

   makeBricks();
   load();
}

void makeBrick(int brickX, int brickY)
{
   brickCoord[brickX][brickY][0][0] = LEFT_BOUND+brickX*brickWidth;     brickCoord[brickX][brickY][0][1] = TOP_BOUND-(ROWS-brickY)*brickHeight;
   brickCoord[brickX][brickY][1][0] = LEFT_BOUND+(brickX+1)*brickWidth; brickCoord[brickX][brickY][0][1] = TOP_BOUND-(ROWS-brickY)*brickHeight;
   brickCoord[brickX][brickY][1][0] = LEFT_BOUND+(brickX+1)*brickWidth; brickCoord[brickX][brickY][1][1] = TOP_BOUND-(ROWS-(brickY+1))*brickHeight;
   brickCoord[brickX][brickY][0][0] = LEFT_BOUND+brickX*brickWidth;     brickCoord[brickX][brickY][1][1] = TOP_BOUND-(ROWS-(brickY+1))*brickHeight;
}

void makeBricks()
{
   int brickX, brickY;
   for (brickY = 0; brickY < ROWS; brickY++)
      for (brickX = 0; brickX < COLUMNS; brickX++)
         makeBrick(brickX, brickY);
}

void initAL()
{
   int i;

   char soundFiles[SOUNDS][17] = {"bat", "bigBat", "brick", "brickChangeColor", "extraLife", "gameOver",
                                "levelUp", "looseLife", "menuMove", "menuSelect", "powerball", "powerUp", "slowDown",
                                "smallBat", "speedUp", "uberBat", "wall"};

   alutInit(0, NULL); /* Initialize OpenAL */

   alGenBuffers(SOUNDS,buffer);
   alGenSources(SOUNDS,source);

   for (i = 0; i < SOUNDS; i++)
      loadWAV(soundFiles[i], &source[i], buffer[i]);

}

void loadWAV(char* name, ALuint* sourceAdd, ALuint bufferAdd)
{
   ALenum format;
   ALsizei size;
   ALvoid* data;
   ALsizei freq;
   ALboolean loop;

   char filename[30] = "sound/";

   strcat(filename, name);
   strcat(filename, ".wav");

   alutLoadWAVFile(filename, &format, &data, &size, &freq, &loop);
   alBufferData(bufferAdd,format,data,size,freq);
   /*alutUnloadWAV(format,data,size,freq);*/
   alSourcei(*sourceAdd, AL_BUFFER, bufferAdd);
}
