/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "input.h"

void keyboardGame(unsigned char key)
{
   switch(key)
   {
   case(27):
      gameSection = SECTION_START_SCREEN;
      break;
   case('q'):
      gameSection = SECTION_GAME_OVER;
      break;
/*
   case('l'):
      newLevel();
      break;
   case('e'):
      endTheLevel();
   case(' '):
      score = 7500;
      gameOver();
      break;
*/
   }
}

void endTheLevel()
{
   int i, j;
   for (i=0; i < ROWS; i++)
      for (j=0; j < COLUMNS; j++)
         brick[j][i] = 0;
   brick[5][0] = 1;
}

void keyboardHighScores(unsigned char key)
{
   int i;
   switch(key)
   {
   case(13):
      playSound(SOUND_MENU_SELECT);
      switch(highScoreSelection)
      {
      case (HIGH_SCORE_BACK):
         startScreen = SECTION_START_SCREEN;
         break;
      case (HIGH_SCORE_CLEAR):
         for (i = 0; i < 5; i++)
         {
            highscores[i] = 0;
            highlevels[i] = 0;
            strcpy(names[i], "   ");
         }
         break;
      }
      break;
   }
}

void keyboardStartGame(unsigned char key)
{
   switch(startScreen)
   {
   case(START_OPENING):
      keyboardStartOpening(key);
      break;
   case(START_HIGH_SCORES):
      keyboardHighScores(key);
      break;
   case(START_OPTIONS):
      keyboardStartOptions(key);
   break;
   }
}

void keyboardStartOpening(unsigned char key)
{
   switch(key)
   {
   case(13):
      playSound(SOUND_MENU_SELECT);
      switch(openingSelection)
      {
      case(SELECTION_NEW_GAME):
         newGame();
         break;
      case(SELECTION_OPTIONS):
         startScreen = START_OPTIONS;
         break;
      case(SELECTION_HIGH_SCORES):
         startScreen = START_HIGH_SCORES;
         break;
      case(SELECTION_EXIT):
         exit(0);
      }
      break;
   }
}

void keyboardStartOptions(unsigned char key)
{
   switch(key)
   {
   case(13):
      playSound(SOUND_MENU_SELECT);
      switch(optionsSelection)
      {
      case(OPTIONS_DIFFICULTY):
         optionInc();
         break;
      case(OPTIONS_SOUND):
         optionInc();
         break;
/*
      case(OPTIONS_MUSIC):
         optionInc();
         break;
*/
      case(OPTIONS_BACK):
         startScreen = START_OPENING;
      }
      break;
   }
}

void keyboardGameOver(unsigned char key)
{
   switch(gameOverSection)
   {
   case GAME_OVER_LOOSE:
      gameSection = SECTION_START_SCREEN;
      break;
   case GAME_OVER_HIGH_SCORE:
      gameOverSection = ENTERING_HIGH_SCORE;
      break;
   case ENTERING_HIGH_SCORE:
      keyboardEnteringHighScore(key);
      break;
   }
}

void keyboardEnteringHighScore(unsigned char key)
{
   switch(key)
   {
   case(13): /*return*/ 
      gameSection = SECTION_START_SCREEN;
      startScreen = START_HIGH_SCORES;
      save();
      break;
   case(8): /*backspace*/
      if (cursor > 0)
         cursor--;
      names[replace][cursor] = ' ';
   default:
      if((key >= 'a' && key <= 'z') || (key >= 'A' && key <='Z'))
      {
         if (cursor > 2)
            cursor = 2;
         names[replace][cursor] = key;
            cursor++;
      }
   }
}

void keyboard(unsigned char key, int x, int y)
{
   switch(gameSection)
   {
   case SECTION_START_SCREEN:
      keyboardStartGame(key);
      break;
   case SECTION_GAME:
      keyboardGame(key);
      break;
   case SECTION_GAME_OVER:
      keyboardGameOver(key);
      break;
   default:
      break;
   }
}

void specialGame(int key)
{
   switch(key)
   {
   case(GLUT_KEY_LEFT):
      processPassiveMotion(oldMouseX-keyBatVelocity, oldMouseY);
      break;
   case(GLUT_KEY_RIGHT):
      processPassiveMotion(oldMouseX+keyBatVelocity, oldMouseY);
      break;
   }
}

void specialStartGame(int key)
{
   switch(startScreen)
   {
   case(START_OPENING):
      specialStartOpening(key);
      break;
   case(START_OPTIONS):
      specialStartOptions(key);
   break;
   case(START_HIGH_SCORES):
      specialHighScores(key);
      break;
   }
}

void specialStartOpening(int key)
{
   if (key == GLUT_KEY_DOWN)
   {
      playSound(SOUND_MENU_MOVE);
      openingSelection++;
      if (openingSelection > 4)
         openingSelection = 1;
   }
   if (key == GLUT_KEY_UP)
   {
      playSound(SOUND_MENU_MOVE);
      openingSelection--;
      if (openingSelection < 1)
         openingSelection = 4;
   }
}

void optionInc()
{
   switch (optionsSelection)
   {
   case(OPTIONS_DIFFICULTY):
      difficulty++;
      if (difficulty > 3)
         difficulty = 1;
      break;
   case(OPTIONS_SOUND):
      if (optionSound == SOUND_ON)
         optionSound = SOUND_OFF;
      else
         optionSound = SOUND_ON;
      break;
/*
   case(OPTIONS_MUSIC):
      if (optionMusic == MUSIC_ON)
         optionMusic = MUSIC_OFF;
      else
         optionMusic = MUSIC_ON;
      break;
*/
   default:
      ;
   }
}

void specialStartOptions(int key)
{
   if (key == GLUT_KEY_DOWN)
   {
      playSound(SOUND_MENU_MOVE);
      optionsSelection++;
      if (optionsSelection > 3)
         optionsSelection = 1;
   }
   if (key == GLUT_KEY_UP)
   {
      playSound(SOUND_MENU_MOVE);
      optionsSelection--;
      if (optionsSelection < 1)
         optionsSelection = 3;
   }

   if (key == GLUT_KEY_RIGHT)
   {
      optionInc();
      playSound(SOUND_MENU_SELECT);
   }

   if (key == GLUT_KEY_LEFT)
   {
      switch (optionsSelection)
      {
      case(OPTIONS_DIFFICULTY):
         difficulty--;
         if (difficulty < 1)
            difficulty = 3;
         break;
      case(OPTIONS_SOUND):
         if (optionSound == SOUND_ON)
            optionSound = SOUND_OFF;
         else
            optionSound = SOUND_ON;
         break;
/*
      case(OPTIONS_MUSIC):
         if (optionMusic == MUSIC_ON)
            optionMusic = MUSIC_OFF;
         else
            optionMusic = MUSIC_ON;
         break;
*/
      default:
      ;
      }
      playSound(SOUND_MENU_SELECT);
   }
}

void special(int key, int x, int y)
{
   switch(gameSection)
   {
   case SECTION_START_SCREEN:
      specialStartGame(key);
      break;
   case SECTION_GAME:
      specialGame(key);
      break;
   case SECTION_GAME_OVER:
      specialGameOver();
      break;
   default:
      break;
   }
}

void processPassiveMotion(int x, int y)
{
   if (gameSection == SECTION_GAME)
   {
      if (oldMouseX == -1)
      {
         oldMouseX = x;
         batX = screenWidth*(float)x/MOUSE_WIDTH;
      }
      else
      {
         batX += screenWidth*(float)(x-oldMouseX)/MOUSE_WIDTH;
         oldMouseX = x;
      }

      if (batX < LEFT_BOUND)
         batX = LEFT_BOUND;
      if (batX + batWidth > RIGHT_BOUND)
         batX = RIGHT_BOUND - batWidth;
   }
}

void processMouse(int button, int state, int x, int y)
{
   if (button == GLUT_LEFT)
      mouse.left = state;
   else
      mouse.right = state;

   if (gameSection == SECTION_GAME)
   {
      if ((button == GLUT_LEFT_BUTTON) && (state == GLUT_DOWN))
      {
         if (holdingBall)
         {
            mouse.left = GLUT_UP;
            launchBall(batX);
         }
         else
            playSound(SOUND_SLOW_DOWN);
      }
   }
}

void processActiveMotion(int x, int y)
{
   processPassiveMotion(x, y);
}

void specialGameOver()
{
   switch(gameOverSection)
   {
   case GAME_OVER_LOOSE:
      gameSection = SECTION_START_SCREEN;
      break;
   case GAME_OVER_HIGH_SCORE:
      gameOverSection = ENTERING_HIGH_SCORE;
      break;
   }
}

void highScoreInc()
{
   if (highScoreSelection == HIGH_SCORE_BACK)
      highScoreSelection = HIGH_SCORE_CLEAR;
   else
      highScoreSelection = HIGH_SCORE_BACK;
   playSound(SOUND_MENU_SELECT);
}

void specialHighScores(int key)
{
   if (key == GLUT_KEY_UP || key == GLUT_KEY_DOWN)
   {
      playSound(SOUND_MENU_MOVE);
      highScoreInc();
   }
}

