/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "render.h"

void reshape(int w, int h)
{
   screenWidth = glutGet(GLUT_WINDOW_WIDTH);
   wRatio = (float)w / (float)WORLD_WIDTH;
   hRatio = (float)h / (float)WORLD_HEIGHT;
   glViewport(0, 0, w, h);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(LEFT, RIGHT, BOTTOM, TOP);
   glMatrixMode(GL_MODELVIEW);
   glutPostRedisplay();
}

void renderStartScreen()
{
   glBegin(GL_QUADS);
      glColor3f(1.0, 0.0, 0.0);
      glVertex2f(LEFT, TOP);
      glColor3f(0.0, 1.0, 0.0);
      glVertex2f(RIGHT, TOP);
      glColor3f(0.0, 0.0, 1.0);
      glVertex2f(RIGHT, BOTTOM);
      glColor3f(1.0, 1.0, 0.0);
      glVertex2f(LEFT, BOTTOM);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);
   glPrintAt(475, 700, "Bounce");
   glPrintAt(450, 650, "by Tim Gradwell");

   if (openingSelection == SELECTION_NEW_GAME)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 200, "New Game");

   if (openingSelection == SELECTION_OPTIONS)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 150, "Options");

   if (openingSelection == SELECTION_HIGH_SCORES)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 100, "High Scores");

   if (openingSelection == SELECTION_EXIT)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400,  50, "Exit");

}

void renderOptions()
{
   glBegin(GL_QUADS);
      glColor3f(1.0, 1.0, 0.0);
      glVertex2f(LEFT, TOP);
      glColor3f(1.0, 0.0, 0.0);
      glVertex2f(RIGHT, TOP);
      glColor3f(0.0, 1.0, 0.0);
      glVertex2f(RIGHT, BOTTOM);
      glColor3f(0.0, 0.0, 1.0);
      glVertex2f(LEFT, BOTTOM);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);
   glPrintAt(475, 700, "Options");

   if (optionsSelection == OPTIONS_DIFFICULTY)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 200, "Difficulty: ");

   if (difficulty == DIFFICULTY_EASY)
   {
      glColor3f(1.0, 1.0, 1.0);
      glPrint("Easy ");
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Normal ");
      glPrint("Hard");
   }
   else if (difficulty == DIFFICULTY_NORMAL)
   {
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Easy ");
      glColor3f(1.0, 1.0, 1.0);
      glPrint("Normal ");
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Hard");
   }
   else
   {
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Easy ");
      glPrint("Normal ");
      glColor3f(1.0, 1.0, 1.0);
      glPrint("Hard");
   }

   if (optionsSelection == OPTIONS_SOUND)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 150, "Sound: ");
   if (optionSound == SOUND_ON)
   {
      glColor3f(1.0, 1.0, 1.0);
      glPrint("On ");
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Off");
   }
   else
   {
      glColor3f(0.0, 0.0, 0.0);
      glPrint("On ");
      glColor3f(1.0, 1.0, 1.0);
      glPrint("Off");
   }

/*
   if (optionsSelection == OPTIONS_MUSIC)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 100, "Music:");
   if (optionMusic == MUSIC_ON)
   {
      glColor3f(1.0, 1.0, 1.0);
      glPrint("On ");
      glColor3f(0.0, 0.0, 0.0);
      glPrint("Off");
   }
   else
   {
      glColor3f(0.0, 0.0, 0.0);
      glPrint("On ");
      glColor3f(1.0, 1.0, 1.0);
      glPrint("Off");
   }
*/

   if (optionsSelection == OPTIONS_BACK)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400,  50, "Back");
}

void renderHighScores()
{
   int i;
   int y;
   char scoreText[5];
   char levelText[4];

   glBegin(GL_QUADS);
      glColor3f(0.0, 0.0, 1.0);
      glVertex2f(LEFT, TOP);
      glColor3f(1.0, 1.0, 0.0);
      glVertex2f(RIGHT, TOP);
      glColor3f(1.0, 0.0, 0.0);
      glVertex2f(RIGHT, BOTTOM);
      glColor3f(0.0, 1.0, 0.0);
      glVertex2f(LEFT, BOTTOM);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 700, "High Scores");

   glPrintAt(200, 600, "Pos:"); glPrintAt(300, 600, "Name:"); glPrintAt(500, 600, "Score:"); glPrintAt(700, 600, "Level:");
   glPrintAt(200, 550, "1st"); 
   glPrintAt(200, 500, "2nd"); 
   glPrintAt(200, 450, "3rd"); 
   glPrintAt(200, 400, "4th"); 
   glPrintAt(200, 350, "5th"); 

   for (i = 0; i < 5; i++)
   {
      y = 550 - 50*i;
      sprintf(scoreText,"%i",highscores[i]);
      sprintf(levelText,"%i",highlevels[i]);
      glPrintAt(300, y, names[i]);   glPrintAt(500, y, scoreText);  glPrintAt(700, y, levelText);
   }

   if (highScoreSelection == HIGH_SCORE_BACK)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(300,  50, "Back");

   if (highScoreSelection == HIGH_SCORE_CLEAR)
      glColor3f(1.0, 1.0, 1.0);
   else
      glColor3f(0.0, 0.0, 0.0);
   glPrintAt(300, 100, "Clear");
}

void renderEnterHighScore()
{
   int i;
   int y;
   char scoreText[5];
   char levelText[4];

   glBegin(GL_QUADS);
      glColor3f(0.0, 1.0, 1.0);
      glVertex2f(LEFT, TOP);
      glColor3f(0.0, 0.5, 1.0);
      glVertex2f(RIGHT, TOP);
      glColor3f(0.0, 1.0, 0.5);
      glVertex2f(RIGHT, BOTTOM);
      glColor3f(0.0, 0.5, 0.5);
      glVertex2f(LEFT, BOTTOM);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);
   glPrintAt(400, 700, "High Scores");

   glPrintAt(200, 600, "Pos:"); glPrintAt(300, 600, "Name:"); glPrintAt(500, 600, "Score:"); glPrintAt(700, 600, "Level:");
   glPrintAt(200, 550, "1st"); 
   glPrintAt(200, 500, "2nd"); 
   glPrintAt(200, 450, "3rd"); 
   glPrintAt(200, 400, "4th"); 
   glPrintAt(200, 350, "5th"); 

   for (i = 0; i < 5; i++)
   {
      y = 550 - 50*i;
      sprintf(scoreText,"%i",highscores[i]);
      sprintf(levelText,"%i",highlevels[i]);
      glPrintAt(300, y, names[i]);   glPrintAt(500, y, scoreText);  glPrintAt(700, y, levelText);
   }
}

void renderExit()
{
}

void renderStartGame()
{
   switch(startScreen)
   {
   case START_OPENING:
      renderStartScreen();
      break;
   case START_OPTIONS:
      renderOptions();
      break;
   case START_HIGH_SCORES:
      renderHighScores();
      break;
   case START_EXIT:
      renderExit();
      break;
   }
}

void renderGame()
{
   renderBoard();
   renderPowerups();
   renderGameText();
   renderSlowdown();
   renderBall();
   renderBat();
}

void renderGameText()
{

   int i;

   char scoreText[5];
   char levelText[2];
   char livesText[2];

   glBegin(GL_QUADS);
      glColor3f(0.0, 0.0, 0.0);
      glVertex2f(RIGHT_BOUND+10.0, TOP_BOUND);
      glVertex2f(RIGHT-10.0, TOP_BOUND);
      glVertex2f(RIGHT-10.0, BOTTOM_BOUND);
      glVertex2f(RIGHT_BOUND+10.0, BOTTOM_BOUND);
   glEnd();

   glColor3f(0.0, 0.0, 0.0);
   glPrintAt(475, 700, "Bounce");

   glColor3f(1.0, 1.0, 1.0);

   glPrintAt(RIGHT_BOUND+20.0, TOP_BOUND-50.0, "Score: "); sprintf(scoreText,"%i",score); glPrint(scoreText);

   glPrintAt(RIGHT_BOUND+20.0, TOP_BOUND-100.0, "Level: "); sprintf(levelText,"%i",level); glPrint(levelText);

   glPrintAt(RIGHT_BOUND+20.0, TOP_BOUND-150.0, "Lives: "); sprintf(livesText,"%i",lives); glPrint(livesText);

   glPrintAt(RIGHT_BOUND+20.0, BOTTOM_BOUND+150.0, "Slowdown: ");

   for (i = 1; i < 8; i++)
      if (powerupEffect[i].effect)
         if (powerupEffect[i].time < POWERUP_TEXT_DISPLAY_TIME)
         {
            glColor3f(1.0, 1.0, 1.0);
            glPrintAt(475, 275, powerupText[i-1]);
         }

}

void renderSlowdown()
{
   glBegin(GL_QUADS);
      glColor3f(1.0, 0.0, 0.0);
      glVertex2f(RIGHT_BOUND+125.0, BOTTOM_BOUND+150.0);
      glVertex2f(RIGHT_BOUND+125.0, BOTTOM_BOUND+165.0);
      glColor3f(0.0, 1.0, 0.0);
      glVertex2f(RIGHT_BOUND+225.0, BOTTOM_BOUND+165.0);
      glVertex2f(RIGHT_BOUND+225.0, BOTTOM_BOUND+150.0);

      glColor3f(0.0, 0.0, 0.0);
      glVertex2f(RIGHT_BOUND+125.0+slowdown, BOTTOM_BOUND+150.0);
      glVertex2f(RIGHT_BOUND+125.0+slowdown, BOTTOM_BOUND+165.0);
      glVertex2f(RIGHT_BOUND+225.0, BOTTOM_BOUND+165.0);
      glVertex2f(RIGHT_BOUND+225.0, BOTTOM_BOUND+150.0);
   glEnd();
}

void renderGameOver()
{
   switch(gameOverSection)
   {
   case GAME_OVER_LOOSE:
   case GAME_OVER_HIGH_SCORE:
      renderGameOverLoose();
      break;
   case ENTERING_HIGH_SCORE:
      renderEnterHighScore();
      break;
   }
}

void renderGameOverLoose()
{
   char scoreText[6];
   char levelText[4];
   glColor3f(1.0, 1.0, 1.0);
   glPrintAt(400, 500, "Game over...");
   glPrintAt(400, 400, "Score: "); sprintf(scoreText,"%i",score); glPrint(scoreText);
   glPrintAt(400, 300, "Level: "); sprintf(levelText,"%i",level); glPrint(levelText);
   if (gameOverSection == GAME_OVER_HIGH_SCORE)
   {
      glColor3f(0.0, 1.0, 0.0);
      glPrintAt(400, 250, "Congratulations - High Score!"); 
   }
   glColor3f(1.0, 1.0, 1.0);
   glPrintAt(400, 200, "Press any key to continue");
}

void renderScene(void)
{
   char fpsText[4];

   glClear(GL_COLOR_BUFFER_BIT);
   switch(gameSection)
   {
   case SECTION_START_SCREEN:
      renderStartGame();
      break;
   case SECTION_GAME:
      renderGame();
      break;
   case SECTION_GAME_OVER:
      renderGameOver();
      break;
   }
   #ifdef FPS
   glColor3f(0.0, 0.0, 0.0);
   sprintf(fpsText, "%i", ifps);
   glPrintAt(0,TOP-24,"FPS: ");
   glPrint(fpsText);
   #endif

   glutSwapBuffers();
}

void renderBoard()
{

   int brickX, brickY;

   glBegin(GL_QUADS);
      /*background*/
      glColor3f (1.0, 0.0, 0.0);
      glVertex2f(0.0, 0.0);
      glColor3f (1.0, 1.0, 0.0);
      glVertex2f(RIGHT, 0.0);
      glColor3f (0.0, 1.0, 0.0);
      glVertex2f(RIGHT, TOP);
      glColor3f (0.0, 0.0, 1.0);
      glVertex2f(0.0, TOP);

      /*board*/
      glColor3f (0.0, 0.0, 0.0);
      glVertex2f(LEFT_BOUND, BOTTOM_BOUND);
      glVertex2f(RIGHT_BOUND, BOTTOM_BOUND);
      glVertex2f(RIGHT_BOUND, TOP_BOUND);
      glVertex2f(LEFT_BOUND, TOP_BOUND);
   glEnd();

   /*bricks*/
   
   for (brickY = 0; brickY < ROWS; brickY++)
      for (brickX = 0; brickX < COLUMNS; brickX++)
         if (brick[brickX][brickY] > 0)
         {
            /*render a brick of the appropriate color*/
           glBegin(GL_QUADS);
               glColor3f (colors[brick[brickX][brickY]][0], colors[brick[brickX][brickY]][1], colors[brick[brickX][brickY]][2]);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][1][1]);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][1][1]);
            glEnd();
           glBegin(GL_LINES);
               glColor3f (0.0, 0.0, 0.0);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][1][1]);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][1][1]);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][0][0], brickCoord[brickX][brickY][1][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][0][1]);
               glVertex2f(brickCoord[brickX][brickY][1][0], brickCoord[brickX][brickY][1][1]);
            glEnd();
         }
   
}

void renderBall()
{
   if (powerupEffect[1].effect)
      glColor3f(1.0, 0.75, 0.4);
   else
      glColor3f(1.0, 1.0, 1.0);
   glBegin(GL_QUADS);
      glVertex2f(ballX, ballY);
      glVertex2f(ballX+ballWidth, ballY);
      glVertex2f(ballX+ballWidth, ballY+ballHeight);
      glVertex2f(ballX, ballY+ballHeight);
   glEnd();
}

void renderBat()
{
   switch(difficulty)
   {
   case(DIFFICULTY_EASY):
      batWidth = BAT_WIDTH_EASY;
      break;
   case(DIFFICULTY_NORMAL):
      batWidth = BAT_WIDTH_NORMAL;
      break;
   case(DIFFICULTY_HARD):
      batWidth = BAT_WIDTH_HARD;
      break;
   }   

   if (powerupEffect[6].effect)
      batWidth*=SPEED_UP;

   if (powerupEffect[7].effect)
      batWidth/=SPEED_UP;

   glColor3f(1.0, 1.0, 1.0);
   glBegin(GL_QUADS);
      glVertex2f(batX, batY);
      glVertex2f(batX+batWidth, batY);
      glVertex2f(batX+batWidth, batY+batHeight);
      glVertex2f(batX, batY+batHeight);
   glEnd();

   if (powerupEffect[3].effect)
   {
      uberBatX = RIGHT_BOUND-(batX-LEFT_BOUND)-batWidth;
      glColor3f(0.2, 1.0, 0.5);
      glBegin(GL_QUADS);
         glVertex2f(uberBatX, batY);
         glVertex2f(uberBatX+batWidth, batY);
         glVertex2f(uberBatX+batWidth, batY+batHeight);
         glVertex2f(uberBatX, batY+batHeight);
      glEnd();
   }
}

void renderPowerups()
{
   int i;

   for (i = 0; i < MAX_POWERUPS; i++)
   {
      if (powerup[i].color > 0)
      {
         glBegin(GL_POINTS);
            glColor3f(colors[powerup[i].color][0], colors[powerup[i].color][1], colors[powerup[i].color][2]);
            glVertex2f(powerup[i].x, powerup[i].y);
         glEnd();
      }
   }
}
