/*
Bounce 0.9
Copyright 2003 Tim Gradwell
Bounce is distributed under the terms of the GNU General Public License 

This file is part of Bounce.

Bounce is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Bounce is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Bounce; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "general.h"
#ifdef DEV_CPP
#include <GL/gl.h>
#endif
#include <GL/glut.h>
#include <stdio.h>
#include <stdlib.h>
#include "gltext.h"
#include "types.h"

extern int ifps;
extern char powerupText[7][12];
extern float ballX, ballY, ballXVelocity, ballYVelocity, ballWidth, ballHeight;
extern float newBallX, newBallY;
extern float batX, batY, batWidth, batHeight;
extern float uberBatX;
extern float brickWidth, brickHeight;
extern float ballVelocity;
extern bool holdingBall;
extern bool ballDownwards;
extern bool ballLeftwards;
extern int oldMouseX, oldMouseY;
extern float brickCoord[COLUMNS][ROWS][2][2];
extern int brick[COLUMNS][ROWS];

extern float wRatio;
extern float hRatio;

extern char names[5][4];
extern int highscores[5];
extern int highlevels[5];

extern int boardWidth;
extern int boardHeight;

extern int powerups;
extern POWERUP powerup[5];
extern POWERUP_EFFECT powerupEffect[8];

extern int score, level, lives;

extern float colors[8][3];
extern int startScreen;
extern int gameSection;
extern int gameOverSection;
extern int openingSelection;
extern int optionsSelection;
extern int highScoreSelection;
extern int exitSelection;
extern int difficulty;
extern int optionSound;
/*extern int optionMusic;*/

extern float slowdown;

extern int screenWidth;
extern int screenHeight;

void reshape(int w, int h);
void renderStartScreen();
void renderOptions();
void renderHighScores();
void renderExit();
void renderStartGame();
void renderGame();
void renderGameOver();
void renderScene(void);
void renderBoard();
void renderBall();
void renderBat();
void renderGameText();
void renderPowerups();
void renderSlowdown();
void renderGameOverLoose();
